Index: ab.c
===================================================================
--- ab.c	(revision 1541509)
+++ ab.c	(working copy)
@@ -334,6 +334,7 @@
 SSL_CTX *ssl_ctx;
 char *ssl_cipher = NULL;
 char *ssl_info = NULL;
+char *key_file = NULL;
 BIO *bio_out,*bio_err;
 #endif
 
@@ -1933,6 +1934,7 @@
 #define TLS1_X_HELP_MSG ""
 #endif
 
+    fprintf(stderr, "    -E keyfile      Specify SSL/TLS combined certificate/keyfile (PEM format)\n");
     fprintf(stderr, "    -Z ciphersuite  Specify SSL/TLS cipher suite (See openssl ciphers)\n");
     fprintf(stderr, "    -f protocol     Specify SSL/TLS protocol\n");
     fprintf(stderr, "                    (" SSL2_HELP_MSG "SSL3, TLS1" TLS1_X_HELP_MSG " or ALL)\n");
@@ -2101,7 +2103,7 @@
     apr_getopt_init(&opt, cntxt, argc, argv);
     while ((status = apr_getopt(opt, "n:c:t:s:b:T:p:u:v:lrkVhwix:y:z:C:H:P:A:g:X:de:SqB:"
 #ifdef USE_SSL
-            "Z:f:"
+            "Z:f:E:"
 #endif
             ,&c, &opt_arg)) == APR_SUCCESS) {
         switch (c) {
@@ -2272,6 +2274,9 @@
             case 'Z':
                 ssl_cipher = strdup(opt_arg);
                 break;
+            case 'E':
+                key_file = strdup(opt_arg);
+                break;
             case 'f':
                 if (strncasecmp(opt_arg, "ALL", 3) == 0) {
                     meth = SSLv23_client_method();
@@ -2358,6 +2363,18 @@
         exit(1);
     }
     }
+    if (key_file != NULL) {
+        if (!SSL_CTX_use_certificate_file(ssl_ctx, key_file, SSL_FILETYPE_PEM)) {
+            fprintf(stderr, "error loading certificate [%s]\n", key_file);
+            ERR_print_errors_fp(stderr);
+            exit(1);
+        }
+        if (!SSL_CTX_use_PrivateKey_file(ssl_ctx, key_file, SSL_FILETYPE_PEM)) {
+            fprintf(stderr, "error loading key [%s]\n", key_file);
+            ERR_print_errors_fp(stderr);
+            exit(1);
+        }
+    }
     if (verbosity >= 3) {
         SSL_CTX_set_info_callback(ssl_ctx, ssl_state_cb);
     }
